#include                              <MATH.H>
#include                            <STRING.H>
#include                               <DIR.H>
#include                               <DOS.H>
#include                             <STDIO.H>
#include                          <GRAPHICS.H>
#include                             <CONIO.H>
#include                            <STDLIB.H>
#include                         "MYMOUSE.CPP"
#include                         "INITGFX.CPP"
#include                           "ARBDEFS.H"
#include                            "BUTTON.H"
#include                          "DATCLASS.H"
#include                            "PROTOS.H"
#include                          "BUTTON.CPP"
#include                        "DATCLASS.CPP"



//----------------------------- intro --------------------------------------
// Display startup screen and wait for mouse click to continue.
void intro(void)
{
	cleardevice();

	box(100,100,440,200);
	setcolor(BLACK);
	outtextxy(272,120,"Arbedit v2.1");
	setcolor(RED);
	outtextxy(172,170,"Electronics Australia, September 1997");
	outtextxy(220,200,"Written by Graham Cattley");
	setcolor(MAGENTA);
	outtextxy(188,280,"Press mouse button to continue...");
	mouse_wait();// Wait until user clicks mouse to exit.
	mouse_wait_up();//Prevents an eroneous edit of the waveform
}

//----------------------------- init_buttons -------------------------------
// setup all 30 buttons with labels, help and pay particular attention
// to the undo button (button #20) which might need to be disabled.
void init_buttons(button* buttonarray)
{
	char *button_name[30]=       //The 30 button labels
	{
		"Change\nheader"			, // Row 1
		"Change\nclock"			,
		"Line"                 	,
		"Add\nNoise"          	,
		"Sine"                 	,
		"Remove\nDC"           	,
		"Shift\nwave dn"       	,
		"Shift\nwave up"       	,
		"Flip X"               	,
		"Flip Y"               	,
		"Clear\nrange"         	, // Row 2
		"Line\nmode"           	,
		"Move to\n0 cross"     	,
		"Mirror\nH.mkrs"       	,
		"Snap to\nmarker"      	,
		"Delete\nunselct"      	,
		"Cut"                  	,
		"Copy"                 	,
		"Paste"                	,
		"Paste\nand add"       	,
		"Undo\naction"         	, // Row 3
		"Save\nwave"           	,
		"Load\nwave"           	,
		"Zoom\nin"             	,
		"Zoom\nout"					,
		" Scroll\n<---"        	,
		" Scroll\n<-"				,
		" Scroll\n          ->"	,// Spaces are printed half width
		" Scroll\n      --->"	,// for centering resons.
		"Quit"
	};

	char *button_help[30]=       // Here's the help messages to go with them.
	{
		"Change waveform description information",
		"Change base clock rate",
		"Draws line from vert/horiz marker 1 to vert/horiz marker 2",
		"Adds random noise to selected area (amplitude = 0 to upper horizontal marker)",
		"Sets selected area to sine wave (amplitude = zero to upper horizontal marker)",
		"Averages the selected waveform and centres it around zero",
		"Shifts the selected part of the waveform down one",
		"Shifts the selected part of the waveform up one",
		"Flips selected part of waveform horizontally",
		"Flips selected part of waveform vertically",
		"Sets the selected range to zero",
		"Draws between mouseclicks in selected area. (Only affects data on zero line.)",
		"Advances marker 2 to the next zero crossing point in the waveform",
		"Mirror horizontal markers around zero on/off",
		"Snap mouse editing to horizontal marker on/off",
		"Moves selected area to start, and clears the rest of the waveform",
		"Cuts selected area to cut/copy buffer",
		"Copies selected area to cut/copy buffer",
		"Pastes (inserts) cut/copy buffer from vertical marker 1",
		"Adds the cut/copy buffer repeatedly to the selected part of the waveform.",
		undo_mode?"Undo last button action (Noise, remove DC, clear, sine, line and del unsel.)":"Undo disabled, run ARBEDIT with /u switch to enable this function.",
		"Saves this waveform to disk (from waveform start to the END marker)",
		"Loads in a waveform file from disk",
		"Zooms in on waveform (x 2)",
		"Zooms out of waveform (x 2)",
		"Scroll window left lots",
		"Scroll window left a bit",
		"Scroll window right a bit",
		"Scroll window right lots",
		"Exit Arbedit and return to good old DOS..."
	};

	int momentary[30]={                     // 1 = button is momentary
							 1,1,1,1,1,1,1,1,1,1, // 0 = button toggles on/off
							 1,0,1,0,0,1,1,1,1,1,
							 1,1,1,1,1,1,1,1,1,1 };

	for(int x=0;x<30;x++)// Go and setup each button
	{                    // and setup correct undo (#20) active/inactive mode
		buttonarray[x].setup((x%10*64)+3,(x/10*31)+377,56,23,
								  momentary[x],((x==20)&&(!undo_mode))?1:0,
								  BUTTONEDGELIGHT,PASSIVEBUTTON,BUTTONEDGEDARK,
								  button_name[x],button_help[x]);

		buttonarray[x].draw();// And while we're at it, go and turn them on.
	}
}
//----------------------------------- box -----------------------------------
// Draws a box with a beveled edge of the dimentions supplied.
void box(int x,int y,int l,int h)
{
	mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);
	setfillstyle(1,BOXCOLOUR);
	bar(x,y,x+l,y+h);

	setcolor(BOXLOWLIGHT);// For the bottom and right edge bevels
	line(x-1,y+h+1,x+l+1,y+h+1);
	line(x-2,y+h+2,x+l+2,y+h+2);
	line(x-3,y+h+3,x+l+3,y+h+3);
	line(x+l+1,y-1,x+l+1,y+h+1);
	line(x+l+2,y-2,x+l+2,y+h+2);
	line(x+l+3,y-3,x+l+3,y+h+3);

	setcolor(BOXHIGHLIGHT);// For the top and left edge highlights
	line(x-1,y-1,x+l+1,y-1);
	line(x-2,y-2,x+l+2,y-2);
	line(x-3,y-3,x+l+3,y-3);
	line(x-1,y-1,x-1,y+h+1);
	line(x-2,y-2,x-2,y+h+2);
	line(x-3,y-3,x-3,y+h+3);

	mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);
}

//-------------------------------- mouse_wait ----------------------------
// Hang around in a DO loop until the user presses a mouse button.
void mouse_wait(void)
{
	do
	{
		mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);
	}
	while (!mouse_button);
}

//------------------------------- mouse_wait_up --------------------------
// Hang around in a DO loop until the user releases a mouse button.
void mouse_wait_up(void)
{
	do
	{
		mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);
	}
	while (mouse_button);
}

//------------------------------ buttons_check ---------------------------
// Returns the number of the button that the mouse clicked on
int buttons_check(button* buttonarray,int numtocheck)
{
	int waspressed=-1,notpressed=0,n;

	for(int x=0;x<numtocheck;x++)// Check each button in turn.
	{
		n=buttonarray[x].mouseover();
		if(n==93) waspressed=x;// Magic Number indicating that the button was pressed
		if(n==0) notpressed++; // Not so Magic Number indicating not pressed.
	}

	if ((notpressed==numtocheck)&&(!blanked))
	{
		mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);
		setfillstyle(1,HELP_BAR_COLOUR);
		bar(0,468,640,480);
		blanked=1;// flag so that we only blank out the button help once.
		mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);
	}
	return(waspressed);
}

//---------------------------- filerequester -----------------------------------
char* filerequester(void)
{
	struct ffblk ffblk;    // used to get a directory from disk.
	char *filter ="*.wfm"; // Filter to give a directory of only .WFM files.
	char files[254][13];   // Array to hold file names -- [file#][name]
	int done=findfirst(filter,&ffblk,0);// More directory stuff...
	int i,start=1;         // start is how far down the list we've scrolled.
	int letter=0,word;     // Used in the filename array.
	int button_pushed;     // a flag.

	button buttons[4];     // An array of buttons used in the requester
	box(100,10,251,186);

	setcolor(LIGHTCYAN);   // list box highlights
	line(211,29,211,144);
	line(105,145,211,145);

	setcolor(BLUE);        // Ditto.
	line(104,30,104,145);
	line(104,29,210,29);

	setfillstyle(1,YELLOW);// Requester title bar.
	bar(104,14,347,25);
	setcolor(RED);
	outtextxy(140,16,"Select a file to load");
	setcolor(BLACK);
	// Setup the four requester buttons...
	buttons[0].setup(220,36,52,20,1,0, LIGHTCYAN,CYAN,BLUE,"    Up","Scroll to previous file");
	buttons[1].setup(220,118,52,20,1,0,LIGHTCYAN,CYAN,BLUE,"  Down","Scroll to next file");
	buttons[2].setup(220,166,52,20,1,0,LIGHTCYAN,CYAN,BLUE,"  Load","Load highlighted file");
	buttons[3].setup(290,166,52,20,1,0,LIGHTCYAN,CYAN,BLUE,"Cancel","Don't load anything");
	for(i=0;i<4;buttons[i++].draw());//    ...and display them.

	for (word=0;word<254;word++)// Flush out the files array
	{
		for(i=0;i<=12;i++)
		{
			files[word][i]=0;
		}
	}

	word=5;// We start adding file names to the array from the fifth position
			 // to leave five blank lines at the start for our selection box.
	while (!done)
	{
		for(letter=0;letter<13;letter++) files[word][letter]=ffblk.ff_name[letter];// Get a filename

		if(word<247) word++;  // If we're not full up, point to the next empty space

		done = findnext(&ffblk); // When we've read in all the files, done !=0
	}

	do
	{
		mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);

		setfillstyle(1,BLACK);
		bar(105,30,210,144);  // Black background for filenames
		setfillstyle(1,CYAN);
		bar(105,82,210,92);   // Selected file bar
		setcolor(WHITE);
		for(i=0;i<9;i++)
		{
			setcolor(i==4?YELLOW:WHITE);// If it's on the select bar, it's yellow
			outtextxy(110,36+(i*12),files[i+start]);//Print the 9 files starting from start
		}
			mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);

		do
		{
			mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);

			button_pushed=buttons_check(buttons,4);//Go and look at the 4 buttons

			if((mouse_x>105)&&(mouse_x<210)&&(mouse_y>30)&&(mouse_y<144)&&(mouse_button))
			{// If you were over a file requester button and you pressed a button
				button_pushed=10+((mouse_y-36)/12); // Calculate which button clicked
			}



			if((kbhit())&&(getch()==27)) return(NULL);//Exit if you pressed ESC
		}
		while(button_pushed<0);

		mouse_wait_up();// Wait until you release mouse button

		switch(button_pushed)
		{
			case 0:// Up
			{
				if(start>1)start--;
				break;
			}

			case 1:// Down
			{
				if (start<word-5)start++;
				break;
			}

			case 2:// Load
			{
				return(files[start+4]);
				break;
			}

		}// end of the switch statement
		if(button_pushed>=10)
		{// This next line lets you click on a filename and it will jump to the select bar (!)
			start=min(word-5,max(5,start+button_pushed-10)-4);
		}
	}
	while(button_pushed!=3);// If it IS 3 then exit.
	return(NULL);
}

// ------------------------- get_string -------------------------------------
char * get_string(char *title,char *prompt,int max_string_length,char *old_string)
{
	int x,y,l,h;                // Requester bottom left corner, length, height
	int button_pushed,extra=0,letter=0;
	char key;
	static char string[80];     //Input string
	button button[2];

	mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);
	mouse_control(MOUSE_RESET,&mouse_x,&mouse_y,&mouse_button);

	for(x=0;x<80;x++) string[x]=0;

	strcpy(string,old_string);// Start working with string passed in to routine
	letter=strlen(string);      // How long is it?

	l=max(200,22+(max_string_length*8)); // Make requester long enough for text
													 // but set a minimum length
	x=320-(l/2); y=32; h=110;   // Centre reqester on screen, set y and height
	box(x,y,l,h);               // Now go and make it

	button[0].setup(x+l-125,y+h-27,52,20,1,0,LIGHTCYAN,CYAN,BLUE,"    OK","Accept input");
	button[1].setup(x+l-63 ,y+h-27,52,20,1,0,LIGHTCYAN,CYAN,BLUE,"Cancel","Cancel");
	button[0].draw();           // Turn on both buttons
	button[1].draw();

	setfillstyle(1,HELP_BAR_COLOUR);
	bar(0,468,640,480);         // Display help message
	setcolor(BLACK);
	outtextxy(10,470,"Press Enter to accept, or ESC to cancel");

	setfillstyle(1,YELLOW);     // Display requester title
	bar(x+(l/2)-((strlen(title)*8)/2)-3,y+6,x+(l/2)+((strlen(title)*8)/2)+3,y+16);
	setcolor(BLACK);
	outtextxy(x+(l/2)-((strlen(title)*8)/2),y+8,title);

	setcolor(YELLOW);           // and the prompt...
	outtextxy(x+12,y+40,prompt);

	if(max_string_length==8) extra=4*8;// If we are getting a file name,
												  // add an extra 4 chars for the extention
	setfillstyle(1,BLACK);
	bar(x+9,y+h-48,x+13+(max_string_length*8)+extra,y+h-38);// Draw text box

	setcolor(BLUE);                                 // Top and left highlights
	line(x+8,y+h-49,x+14+(max_string_length*8)+extra,y+h-49);
	line(x+8,y+h-49,x+8,y+h-37);

	setcolor(LIGHTCYAN);                         //Bottom and right highlights
	line(x+8,y+h-37,x+14+(max_string_length*8)+extra,y+h-37);
	line(x+14+(max_string_length*8)+extra,y+h-49,x+14+(max_string_length*8)+extra,y+h-37);

	setcolor(YELLOW);
	outtextxy(x+12,y+h-46,string);// Print the old string in the text box
	if(letter<max_string_length)// If we have room, print cursor
	{
		setcolor(WHITE);         // Cursor is white
		outtextxy(x+12+strlen(string)*8,y+h-46,"_");// And its an underscore too
		setcolor(YELLOW);
	}

	//If its a filename we're getting, force a WFM extention on the end
	if(max_string_length==8) outtextxy(x+12+strlen(string)*8,y+h-46,".wfm");

	mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);

	while(key!=13)// Now check for key presses...
	{
		key=0;
		while (!key)
		{
			mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);

			if (kbhit()) key=getch(); // If you pressed a key, get it
			button_pushed=buttons_check(button,2);// and check the buttons too
			if (button_pushed==0)key=13; // Buttons are the same as key presses,
			if (button_pushed==1)key=27; // so why not do it this way?
		}

		mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);

		if(key==27) // pressed ESC?
		{
			mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);
			return("~~~~~");// Magic String indicating esc pressed
		}
		//---------------
		if((key==8)&&(letter>0)) // you pushed backspace, and it's valid
		{
			letter--;
			string[letter]=0;// re-terminate string

			setfillstyle(1,BLACK);// redraw box, and print new string
			bar(x+9,y+h-48,x+13+(max_string_length*8)+extra,y+h-38);
			outtextxy(x+12,y+h-46,string);
		}

		if((key!=13)&&(key!=8)&&(key!=0)&&(letter<max_string_length))
		{// it's not a funny key, and you're below max string len
			string[letter]=key;
			letter++;
			setfillstyle(1,BLACK);
			bar(x+9,y+h-48,x+13+(max_string_length*8)+extra,y+h-38);
			outtextxy(x+12,y+h-46,string);
		}


		if(letter<max_string_length)// redraw cursor, if room
		{
			setcolor(WHITE);
			outtextxy(x+12+strlen(string)*8,y+h-46,"_");
			setcolor(YELLOW);
		}

		if(max_string_length==8)// it's a filename!
		{
			outtextxy(x+12+strlen(string)*8,y+h-46,".wfm");// force .wfm
		}
		mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);

	}// end while key not 13
	return(string);
}

//============================= main =====================================
int main(int argc, char* argv)
{
	dataclass data;
	button buttons[30];
	int button_pushed;
	int newspeed;
	char *filename,*temp;
	if ((argc>1)&&(strcmp(argv,"/u"))) undo_mode=1;// Check for 'undo' switch on command line

	printf("\n\nThis program needs a 640 x 480 x 16 colour screen\n\r");
	init_graphics();
	mouse_control(MOUSE_RESET,&mouse_x,&mouse_y,&mouse_button);
	mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);
	intro();
	mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);
	init_buttons(buttons);
	data.draw();
	mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);

	do
	{
		mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);
		button_pushed=buttons_check(buttons,NUMBER_OF_BUTTONS);
		data.mousecheck();
		while(kbhit())getch();
		switch(button_pushed)
		{
			case -1:// No button was pushed, so skip to end...
			{

			break;}

			case 0:// Change header
			{
				strcpy(temp,get_string("CHANGE HEADER","Please enter new header text:",57,data.header));
				if(strcmp(temp,"~~~~~")!=0) strcpy(data.header,temp);

			break;}

			case 1:// Change clock
			{
				if(data.clock_speed==6) newspeed=2;
				if(data.clock_speed==2) newspeed=0;
				if(data.clock_speed==0) newspeed=6;
				data.clock_speed=newspeed;

			break;}

			case 2:// Line
			{
				data.line_button();

			break;}

			case 3:// Add noise
			{
				data.noise();

			break;}

			case 4:// Sine
			{
				data.sine();

			break;}

			case 5:// Remove DC
			{
				data.remove_dc();

			break;}

			case 6:// Shift wave down
			{
				data.shiftdown();

			break;}

			case 7:// Shift wave up
			{
				data.shiftup();

			break;}

			case 8:// Filp X
			{
				data.flip_x();

			break;}

			case 9:// Flip Y
			{
				data.flip_y();

			break;}

			case 10:// Clear range
			{
				data.clear_button();

			break;}

			case 11:// Line mode
			{
				data.linemode=buttons[11].read();

			break;}

			case 12:// Move to 0 crossing point
			{
				data.zero_cross();

			break;}

			case 13:// Mirror Horzontal markers
			{
				data.h_symmetry = buttons[13].read();

			break;}

			case 14:// Snap to markers
			{
				data.snap=buttons[14].read();

			break;}

			case 15:// Clip 'n' rip
			{
				data.kill_the_rest();

			break;}

			case 16:// Cut
			{
				data.cut();

			break;}

			case 17:// Copy
			{
				data.copy();

			break;}

			case 18:// Paste
			{
				data.paste();

			break;}

			case 19:// Paste and add
			{
				data.add();

			break;}

			case 20:// Undo
			{
				data.undo_button();

			break;}

			case 21:// Save waveform
			{
				temp=get_string("CHANGE HEADER","Do you want to update the header text before you save?",57,data.header);
				if(strcmp(temp,"~~~~~")!=0)
				{
					strcpy(data.header,temp);
					data.draw();
					data.save();
				}

			break;}

			case 22:// Load waveform
			{
				if(filename=filerequester()) data.load(filename);

			break;}

			case 23:// Zoom in
			{
				data.zoomin();

			break;}

			case 24:// Zoom out
			{
				data.zoomout();

			break;}

			case 25:// Scroll left lots
			{
				data.scroll_left(200);

			break;}

			case 26:// Scroll left a little
			{
				data.scroll_left(50);

			break;}

			case 27:// Scroll right a little
			{
				data.scroll_right(50);

			break;}

			case 28:// Scroll right lots
			{
				data.scroll_right(200);

			break;}

	  }
	  if(button_pushed>-1)data.draw();
	} while (button_pushed!=29);// Err, Quit

	undo_mode=1;  // Force undo mode on so that we can...
	data.undo();  // Save the current waveform in case they exited by mistake.

	closegraph(); // Put things back after you've played with them,
	return(0);    // and exit to DOS gracefully.

}

