//----------------------------- button --------------------------------------
void button::button()
{
	clicked=0;
	indented=0;
}

void button::setup(int newx,int newy,int newl,int newh,int newmomentary,
							int newinactive,int newtopleft,int newface,int newbottomright,
							char *thetext,char *thehelp)
{
	int i       =0;
	numlines    =0;
	momentary   =newmomentary;
	inactive    =newinactive;
	x           =newx;
	y           =newy;
	l           =newl;
	h           =newh;
	topleft     =newtopleft;
	face        =newface;
	bottomright =newbottomright;
	text        =thetext;
	help        =thehelp;

	do
	{
		if(text[i]=='\n') numlines++;
	}
	while(text[i++]);
}

void button::draw()
{
	int textx,texty;
	int offset;
	char str[2]="X";

	mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);

	offset=3*(indented==1)+2;

	setfillstyle(1,face);
	bar(x,y,x+l,y+h);

	setcolor(bottomright);
	line(x-1,y+h+1,x+l+1,y+h+1);
	line(x-2,y+h+2,x+l+2,y+h+2);
	line(x-3,y+h+3,x+l+3,y+h+3);
	line(x+l+1,y-1,x+l+1,y+h+1);
	line(x+l+2,y-2,x+l+2,y+h+2);
	line(x+l+3,y-3,x+l+3,y+h+3);

	setcolor(topleft);
	line(x-1,y-1,x+l+1,y-1);
	line(x-2,y-2,x+l+2,y-2);
	line(x-3,y-3,x+l+3,y-3);
	line(x-1,y-1,x-1,y+h+1);
	line(x-2,y-2,x-2,y+h+2);
	line(x-3,y-3,x-3,y+h+3);

	setcolor(inactive?DARKGRAY:WHITE*indented);

	textx=x+offset;
	texty=y+(h/2)-(numlines*6)-3;
	for(int i=0;i<strlen(text);i++)
	{
		switch(text[i])
		{
			case '\n':
			{
				textx=x+offset;
				texty+=10;
				break;
			}

			case ' ':
			{
				textx+=4;
				break;
			}

			default:
			{
				str[0]=text[i];
				outtextxy(textx,texty,str);
				textx +=8;
			}
		}
	}
	mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);

}


void button::click()
{
	if(inactive)
	{
		mouse_wait_up();
		return;
	}
	int temp=topleft;
	topleft=bottomright;
	bottomright=temp;
	indented=!indented;
	draw();
	do
	{
		mouse_control(MOUSE_POSITION_BUTTONS,&mouse_x,&mouse_y,&mouse_button);
	} while (mouse_button);

	if(momentary)
	{
		temp=topleft;
		topleft=bottomright;
		bottomright=temp;
		indented=!indented;
		draw();
		clicked=1;
	}
}

int button::mouseover()
{
	static char *id;

	gotoxy(1,1);
//	printf("x=%d:y=%d   ",x,y);
	if(((mouse_x>=x)&&(mouse_x<=x+l))&&((mouse_y>=y)&&(mouse_y<=y+h)))
	{
		if(mouse_button)
		{
			click();
			return(93);
		}
		if ((id!=help)||(blanked))// Almighty kluge, uses a global.
		{
			mouse_control(MOUSE_HIDE,&mouse_x,&mouse_y,&mouse_button);
			setfillstyle(1,HELP_BAR_COLOUR);
			bar(0,468,640,480);
			setcolor(BLACK);
			outtextxy(10,470,help);
			blanked=0;
			id=help;
			mouse_control(MOUSE_SHOW,&mouse_x,&mouse_y,&mouse_button);
		}
		return(107);
	}
	else return(0);
}

int button::read()
{
	int return_value;

	if(momentary)
	{
		return_value=clicked;
		clicked=0;
	}
	else return_value=indented;
	return(return_value);
}




